<template>
  <v-row>
    <v-col>
      <head-bar :title="pageTitle" />

      <!-- Deliveries in progress -->
      <h2><v-icon>mdi-progress-clock</v-icon>Current deliveries</h2>
      <delivery-list :deliveries="currentDeliveries"></delivery-list>

      <!-- Deliveries history -->
      <h2><v-icon>mdi-history</v-icon>Past deliveries</h2>
      <delivery-list :deliveries="pastDeliveries"></delivery-list>
    </v-col>
  </v-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      pageTitle: 'Deliveries',
      deliveries: [],
    }
  },
  computed: {
    currentDeliveries(): Array<object> {
      return this.deliveries.filter((delivery: any) =>
        ['preparing', 'prepared', 'delivering'].includes(delivery.status)
      )
    },
    pastDeliveries(): Array<object> {
      return this.deliveries.filter((delivery: any) =>
        ['delivered', 'cancelled'].includes(delivery.status)
      )
    },
  },
  mounted() {
    this.getDeliveries()
  },
  methods: {
    async getDeliveries() {
      this.deliveries = await this.$axios.$get(
        'http://delivery.localhost:4000/orders'
      )
    },
  },
})
</script>
